import { Token, TokenType } from './types';
export interface StackData {
    stack: Token[];
    start: number;
}
/**
 * Check if given string is whitespace-only
 */
export declare function isWhitespace(str: string): boolean;
/**
 * Check if given token has specified `type`
 */
export declare function isType(token: Token | undefined, type: TokenType): boolean;
/**
 * Check if given token contains tag
 */
export declare function isTagToken(token: Token): boolean;
/**
 * Collects element stack for given text location
 */
export declare function getElementStack(tokens: Token[], pos: number): StackData;
/**
 * Returns last item in given array
 */
export declare function last<T>(arr: T[]): T | undefined;
/**
 * Diff token factory
 */
export declare function diffToken(name: string, value: string, location: number, text?: string): Token;
export declare function isDiffToken(token: Token): boolean;
/**
 * Finds closest index of of element with given name in `elems` list.
 * Returns `-1` if element is not found
 */
export declare function closest(elems: Token[], name: string): number;
